Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -2102,271 +2548,294 @@
                                                  tend           !< tendency
 
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-
-             IF ( pave_surface(j,i) )  THEN
-                rho_c_total(nzb_soil,j,i) = pave_heat_capacity
-                lambda_temp(nzb_soil)     = pave_heat_conductivity
+       TYPE(surf_type_lsm), POINTER ::  surf_m_soil
+       TYPE(surf_type_lsm), POINTER ::  surf_m_soil_p
+       TYPE(surf_type_lsm), POINTER ::  surf_t_soil
+       TYPE(surf_type_lsm), POINTER ::  surf_t_soil_p
+       TYPE(surf_type_lsm), POINTER ::  surf_tm_soil_m
+       TYPE(surf_type_lsm), POINTER ::  surf_tt_soil_m
+
+       TYPE(surf_type), POINTER  ::  surf  !< surface-date type variable
+
+       IF ( horizontal )  THEN
+          surf           => surf_lsm_h
+
+          surf_m_soil    => m_soil_h
+          surf_m_soil_p  => m_soil_h_p
+          surf_t_soil    => t_soil_h
+          surf_t_soil_p  => t_soil_h_p
+          surf_tm_soil_m => tm_soil_h_m
+          surf_tt_soil_m => tt_soil_h_m
+       ELSE
+          surf           => surf_lsm_v(l)
+
+          surf_m_soil    => m_soil_v(l)
+          surf_m_soil_p  => m_soil_v_p(l)
+          surf_t_soil    => t_soil_v(l)
+          surf_t_soil_p  => t_soil_v_p(l)
+          surf_tm_soil_m => tm_soil_v_m(l)
+          surf_tt_soil_m => tt_soil_v_m(l)
+       ENDIF
+
+       DO  m = 1, surf%ns
+
+          IF ( surf%pave_surface(m) )  THEN
+             surf%rho_c_total(nzb_soil,m) = pave_heat_capacity
+             lambda_temp(nzb_soil)          = pave_heat_conductivity
+          ENDIF
+
+          IF (  .NOT.  surf%water_surface(m) )  THEN
+             DO  k = nzb_soil, nzt_soil
+
+                IF ( surf%pave_surface(m)  .AND.  zs(k) <= pave_depth )  THEN
+                    
+                   surf%rho_c_total(k,m) = pave_heat_capacity
+                   lambda_temp(k)        = pave_heat_conductivity   
+
+                ELSE            
+!
+!--                Calculate volumetric heat capacity of the soil, taking 
+!--                into account water content 
+                   surf%rho_c_total(k,m) = (rho_c_soil *                 &
+                                               ( 1.0_wp - surf%m_sat(m) )&
+                                               + rho_c_water * surf_m_soil%var_2d(k,m) )
+
+!
+!--                Calculate soil heat conductivity at the center of the soil
+!--                layers
+                   lambda_h_sat = lambda_h_sm**(1.0_wp - surf%m_sat(m)) *&
+                                  lambda_h_water ** surf_m_soil%var_2d(k,m)
+
+                   ke = 1.0_wp + LOG10( MAX( 0.1_wp, surf_m_soil%var_2d(k,m) /             &
+                                                     surf%m_sat(m) ) )
+
+                   lambda_temp(k) = ke * (lambda_h_sat - lambda_h_dry) +       &
+                                    lambda_h_dry
+                ENDIF
+             ENDDO
+
+!
+!--          Calculate soil heat conductivity (lambda_h) at the _stag level 
+!--          using linear interpolation. For pavement surface, the
+!--          true pavement depth is considered
+             DO  k = nzb_soil, nzt_soil-1
+                IF ( surf%pave_surface(m)  .AND.  zs(k)   < pave_depth   &
+                                                 .AND.  zs(k+1) > pave_depth )  THEN
+                   surf%lambda_h(k,m) = ( pave_depth - zs(k) ) / dz_soil(k+1)&
+                                     * lambda_temp(k)                          &
+                                     + ( 1.0_wp - ( pave_depth - zs(k) )       &
+                                     / dz_soil(k+1) ) * lambda_temp(k+1)
+                ELSE
+                   surf%lambda_h(k,m) = ( lambda_temp(k+1) + lambda_temp(k) )&
+                                     * 0.5_wp
+                ENDIF
+             ENDDO
+             surf%lambda_h(nzt_soil,m) = lambda_temp(nzt_soil)
+
+!
+!--          Prognostic equation for soil temperature t_soil
+             tend(:) = 0.0_wp
+
+             tend(nzb_soil) = ( 1.0_wp / surf%rho_c_total(nzb_soil,m) ) *&
+                    ( surf%lambda_h(nzb_soil,m) * ( surf_t_soil%var_2d(nzb_soil+1,m) &
+                      - surf_t_soil%var_2d(nzb_soil,m) ) * ddz_soil(nzb_soil+1)            &
+                      + surf%ghf_eb(m) ) * ddz_soil_stag(nzb_soil)
+
+             DO  k = nzb_soil+1, nzt_soil
+                tend(k) = ( 1.0_wp / surf%rho_c_total(k,m) )             &
+                          * (   surf%lambda_h(k,m)                       &
+                              * ( surf_t_soil%var_2d(k+1,m) - surf_t_soil%var_2d(k,m) )                &
+                              * ddz_soil(k+1)                                  &
+                              - surf%lambda_h(k-1,m)                     &
+                              * ( surf_t_soil%var_2d(k,m) - surf_t_soil%var_2d(k-1,m) )                &
+                              * ddz_soil(k)                                    &
+                            ) * ddz_soil_stag(k)
+
+             ENDDO
+
+             surf_t_soil_p%var_2d(nzb_soil:nzt_soil,m) = surf_t_soil%var_2d(nzb_soil:nzt_soil,m)       &
+                                               + dt_3d * ( tsc(2)              &
+                                               * tend(nzb_soil:nzt_soil)       & 
+                                               + tsc(3)                        &
+                                               * surf_tt_soil_m%var_2d(nzb_soil:nzt_soil,m) )
+
+!
+!--          Calculate t_soil tendencies for the next Runge-Kutta step
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                   DO  k = nzb_soil, nzt_soil
+                      surf_tt_soil_m%var_2d(k,m) = tend(k)
+                   ENDDO
+                ELSEIF ( intermediate_timestep_count <                         &
+                         intermediate_timestep_count_max )  THEN
+                   DO  k = nzb_soil, nzt_soil
+                      surf_tt_soil_m%var_2d(k,m) = -9.5625_wp * tend(k) + 5.3125_wp        &
+                                         * surf_tt_soil_m%var_2d(k,m)
+                   ENDDO
+                ENDIF
              ENDIF
 
-             IF (  .NOT.  water_surface(j,i) )  THEN
+
+             DO  k = nzb_soil, nzt_soil
+
+!
+!--             Calculate soil diffusivity at the center of the soil layers
+                lambda_temp(k) = (- b_ch * surf%gamma_w_sat(m) * psi_sat     &
+                                  / surf%m_sat(m) ) * ( MAX( surf_m_soil%var_2d(k,m),    &
+                                  surf%m_wilt(m) ) / surf%m_sat(m) )**(&
+                                                            b_ch + 2.0_wp )
+
+!
+!--             Parametrization of Van Genuchten
+                IF ( soil_type /= 7 )  THEN
+!
+!--                Calculate the hydraulic conductivity after Van Genuchten 
+!--                (1980)
+                   h_vg = ( ( ( surf%m_res(m) - surf%m_sat(m) ) /  &
+                              ( surf%m_res(m) -                          &
+                                MAX( surf_m_soil%var_2d(k,m), surf%m_wilt(m) )       &
+                              )                                                &
+                            )**(                                               &
+                          surf%n_vg(m) / ( surf%n_vg(m) - 1.0_wp ) &
+                               ) - 1.0_wp                                      &
+                          )**( 1.0_wp / surf%n_vg(m) ) / surf%alpha_vg(m)
+
+                   gamma_temp(k) = surf%gamma_w_sat(m) * ( ( ( 1.0_wp +  &
+                          ( surf%alpha_vg(m) * h_vg )**surf%n_vg(m)&
+                                                               )**(            &
+                              1.0_wp - 1.0_wp / surf%n_vg(m)) - (        &
+                          surf%alpha_vg(m) * h_vg )**( surf%n_vg(m)&
+                              - 1.0_wp) )**2 )                                 &
+                              / ( ( 1.0_wp + ( surf%alpha_vg(m) * h_vg   &
+                              )**surf%n_vg(m) )**( ( 1.0_wp  - 1.0_wp    &
+                              / surf%n_vg(m) ) *                         &
+                              ( surf%l_vg(m) + 2.0_wp) ) )
+!
+!--             Parametrization of Clapp & Hornberger
+                ELSE
+                   gamma_temp(k) = surf%gamma_w_sat(m) * ( surf_m_soil%var_2d(k,m)   &
+                                   / surf%m_sat(m) )**(2.0_wp * b_ch + 3.0_wp)
+                ENDIF
+
+             ENDDO
+
+!
+!--          Prognostic equation for soil moisture content. Only performed,
+!--          when humidity is enabled in the atmosphere and the surface type
+!--          is not pavement (implies dry soil below).
+             IF ( humidity  .AND.  .NOT.  surf%pave_surface(m) )  THEN
+!
+!--             Calculate soil diffusivity (lambda_w) at the _stag level 
+!--             using linear interpolation. To do: replace this with
+!--             ECMWF-IFS Eq. 8.81
+                DO  k = nzb_soil, nzt_soil-1
+                    
+                   surf%lambda_w(k,m) = ( lambda_temp(k+1) +             &
+                                                lambda_temp(k) ) * 0.5_wp
+                   surf%gamma_w(k,m)  = ( gamma_temp(k+1)  +             &
+                                                gamma_temp(k) )  * 0.5_wp
+
+                ENDDO
+
+!
+!
+!--             In case of a closed bottom (= water content is conserved), 
+!--             set hydraulic conductivity to zero to that no water will be 
+!--             lost in the bottom layer.
+                IF ( conserve_water_content )  THEN
+                   surf%gamma_w(nzt_soil,m) = 0.0_wp
+                ELSE
+                   surf%gamma_w(nzt_soil,m) = gamma_temp(nzt_soil)
+                ENDIF     
+
+!--             The root extraction (= root_extr * qsws_veg_eb / (rho_l     
+!--             * l_v)) ensures the mass conservation for water. The         
+!--             transpiration of plants equals the cumulative withdrawals by 
+!--             the roots in the soil. The scheme takes into account the 
+!--             availability of water in the soil layers as well as the root 
+!--             fraction in the respective layer. Layer with moisture below 
+!--             wilting point will not contribute, which reflects the 
+!--             preference of plants to take water from moister layers.
+!
+!--             Calculate the root extraction (ECMWF 7.69, the sum of 
+!--             root_extr = 1). The energy balance solver guarantees a 
+!--             positive transpiration, so that there is no need for an 
+!--             additional check.
+                m_total = 0.0_wp
                 DO  k = nzb_soil, nzt_soil
-
-
-                   IF ( pave_surface(j,i)  .AND.  zs(k) <= pave_depth )  THEN
-                    
-                      rho_c_total(k,j,i) = pave_heat_capacity
-                      lambda_temp(k)     = pave_heat_conductivity   
-
-                   ELSE            
-!
-!--                   Calculate volumetric heat capacity of the soil, taking 
-!--                   into account water content 
-                      rho_c_total(k,j,i) = (rho_c_soil * (1.0_wp - m_sat(j,i)) &
-                                           + rho_c_water * m_soil(k,j,i))
-
-!
-!--                   Calculate soil heat conductivity at the center of the soil
-!--                   layers
-                      lambda_h_sat = lambda_h_sm ** (1.0_wp - m_sat(j,i)) *    &
-                                     lambda_h_water ** m_soil(k,j,i)
-
-                      ke = 1.0_wp + LOG10(MAX(0.1_wp,m_soil(k,j,i)             &
-                                                     / m_sat(j,i)))
-
-                      lambda_temp(k) = ke * (lambda_h_sat - lambda_h_dry) +    &
-                                       lambda_h_dry
-                   ENDIF
-
+                    IF ( surf_m_soil%var_2d(k,m) > surf%m_wilt(m) )  THEN
+                       m_total = m_total + surf%root_fr(k,m) * surf_m_soil%var_2d(k,m)
+                    ENDIF
+                ENDDO  
+                 IF ( m_total > 0.0_wp )  THEN
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( surf_m_soil%var_2d(k,m) > surf%m_wilt(m) )  THEN
+                         root_extr(k) = surf%root_fr(k,m) * surf_m_soil%var_2d(k,m)  &
+                                                            / m_total
+                      ELSE
+                         root_extr(k) = 0.0_wp
+                      ENDIF
+                   ENDDO
+                ENDIF
+!
+!--             Prognostic equation for soil water content m_soil_h.
+                tend(:) = 0.0_wp
+
+                tend(nzb_soil) = ( surf%lambda_w(nzb_soil,m) *   (       &
+                         surf_m_soil%var_2d(nzb_soil+1,m) - surf_m_soil%var_2d(nzb_soil,m) )           &
+                         * ddz_soil(nzb_soil+1) - surf%gamma_w(nzb_soil,m) - &
+                                                     (                         &
+                            root_extr(nzb_soil) * surf%qsws_veg_eb(m)    &
+                            + surf%qsws_soil_eb(m) ) * drho_l_lv )       &
+                            * ddz_soil_stag(nzb_soil)
+
+                DO  k = nzb_soil+1, nzt_soil-1
+                   tend(k) = ( surf%lambda_w(k,m) * ( surf_m_soil%var_2d(k+1,m)      &
+                             - surf_m_soil%var_2d(k,m) ) * ddz_soil(k+1)                   &
+                             - surf%gamma_w(k,m)                         &
+                             - surf%lambda_w(k-1,m) * ( surf_m_soil%var_2d(k,m) -    &
+                             surf_m_soil%var_2d(k-1,m)) * ddz_soil(k)                      &
+                             + surf%gamma_w(k-1,m) - (root_extr(k)       &
+                             * surf%qsws_veg_eb(m) * drho_l_lv)          &
+                             ) * ddz_soil_stag(k)
                 ENDDO
-
-!
-!--             Calculate soil heat conductivity (lambda_h) at the _stag level 
-!--             using linear interpolation. For pavement surface, the
-!--             true pavement depth is considered
-                DO  k = nzb_soil, nzt_soil-1
-                   IF ( pave_surface(j,i)  .AND.  zs(k)   < pave_depth         &
-                                           .AND.  zs(k+1) > pave_depth )  THEN
-                      lambda_h(k,j,i) = ( pave_depth - zs(k) ) / dz_soil(k+1)  &
-                                        * lambda_temp(k)                       &
-                                        + ( 1.0_wp - ( pave_depth - zs(k) )    &
-                                        / dz_soil(k+1) ) * lambda_temp(k+1)
-                   ELSE
-                      lambda_h(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) )  &
-                                        * 0.5_wp
-                   ENDIF
+                tend(nzt_soil) = ( - surf%gamma_w(nzt_soil,m)            &
+                                     - surf%lambda_w(nzt_soil-1,m)       &
+                                     * ( surf_m_soil%var_2d(nzt_soil,m)                    &
+                                     - surf_m_soil%var_2d(nzt_soil-1,m))                   &
+                                     * ddz_soil(nzt_soil)                      &
+                                     + surf%gamma_w(nzt_soil-1,m) - (    &
+                                       root_extr(nzt_soil)                     &
+                                     * surf%qsws_veg_eb(m) * drho_l_lv ) &
+                                  ) * ddz_soil_stag(nzt_soil)             
+
+                surf_m_soil_p%var_2d(nzb_soil:nzt_soil,m) = surf_m_soil%var_2d(nzb_soil:nzt_soil,m)    &
+                                                + dt_3d * ( tsc(2) * tend(:)   &
+                                                + tsc(3) * surf_tm_soil_m%var_2d(:,m) )   
+   
+!
+!--             Account for dry soils (find a better solution here!)
+                DO  k = nzb_soil, nzt_soil
+                   IF ( surf_m_soil_p%var_2d(k,m) < 0.0_wp )  surf_m_soil_p%var_2d(k,m) = 0.0_wp
                 ENDDO
-                lambda_h(nzt_soil,j,i) = lambda_temp(nzt_soil)
-
-
-
-
-!
-!--             Prognostic equation for soil temperature t_soil
-                tend(:) = 0.0_wp
-
-                tend(nzb_soil) = (1.0_wp/rho_c_total(nzb_soil,j,i)) *          &
-                          ( lambda_h(nzb_soil,j,i) * ( t_soil(nzb_soil+1,j,i)  &
-                            - t_soil(nzb_soil,j,i) ) * ddz_soil(nzb_soil+1)    &
-                            + ghf_eb(j,i) ) * ddz_soil_stag(nzb_soil)
-
-                DO  k = nzb_soil+1, nzt_soil
-                   tend(k) = (1.0_wp/rho_c_total(k,j,i))                       &
-                             * (   lambda_h(k,j,i)                             &
-                                 * ( t_soil(k+1,j,i) - t_soil(k,j,i) )         &
-                                 * ddz_soil(k+1)                               &
-                                 - lambda_h(k-1,j,i)                           &
-                                 * ( t_soil(k,j,i) - t_soil(k-1,j,i) )         &
-                                 * ddz_soil(k)                                 &
-                               ) * ddz_soil_stag(k)
-
-                ENDDO
-
-                t_soil_p(nzb_soil:nzt_soil,j,i) = t_soil(nzb_soil:nzt_soil,j,i)&
-                                                  + dt_3d * ( tsc(2)           &
-                                                  * tend(nzb_soil:nzt_soil)    & 
-                                                  + tsc(3)                     &
-                                                  * tt_soil_m(:,j,i) )   
-
-!
-!--             Calculate t_soil tendencies for the next Runge-Kutta step
+
+!
+!--             Calculate m_soil tendencies for the next Runge-Kutta step
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( intermediate_timestep_count == 1 )  THEN
                       DO  k = nzb_soil, nzt_soil
-                         tt_soil_m(k,j,i) = tend(k)
+                         surf_tm_soil_m%var_2d(k,m) = tend(k)
                       ENDDO
                    ELSEIF ( intermediate_timestep_count <                      &
                             intermediate_timestep_count_max )  THEN
                       DO  k = nzb_soil, nzt_soil
-                         tt_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp   &
-                                         * tt_soil_m(k,j,i)
+                         surf_tm_soil_m%var_2d(k,m) = -9.5625_wp * tend(k) + 5.3125_wp     &
+                                  * surf_tm_soil_m%var_2d(k,m)
                       ENDDO
                    ENDIF
                 ENDIF
-
-
-                DO  k = nzb_soil, nzt_soil
-
-!
-!--                Calculate soil diffusivity at the center of the soil layers
-                   lambda_temp(k) = (- b_ch * gamma_w_sat(j,i) * psi_sat       &
-                                     / m_sat(j,i) ) * ( MAX( m_soil(k,j,i),    &
-                                     m_wilt(j,i) ) / m_sat(j,i) )**(           &
-                                     b_ch + 2.0_wp )
-
-!
-!--                Parametrization of Van Genuchten
-                   IF ( soil_type /= 7 )  THEN
-!
-!--                   Calculate the hydraulic conductivity after Van Genuchten 
-!--                   (1980)
-                      h_vg = ( ( (m_res(j,i) - m_sat(j,i)) / ( m_res(j,i) -    &
-                                 MAX( m_soil(k,j,i), m_wilt(j,i) ) ) )**(      &
-                                 n_vg(j,i) / (n_vg(j,i) - 1.0_wp ) ) - 1.0_wp  &
-                             )**( 1.0_wp / n_vg(j,i) ) / alpha_vg(j,i)
-
-
-                      gamma_temp(k) = gamma_w_sat(j,i) * ( ( (1.0_wp +         &
-                                      ( alpha_vg(j,i) * h_vg )**n_vg(j,i))**(  &
-                                      1.0_wp - 1.0_wp / n_vg(j,i) ) - (        &
-                                      alpha_vg(j,i) * h_vg )**( n_vg(j,i)      &
-                                      - 1.0_wp) )**2 )                         &
-                                      / ( ( 1.0_wp + ( alpha_vg(j,i) * h_vg    &
-                                      )**n_vg(j,i) )**( ( 1.0_wp  - 1.0_wp     &
-                                      / n_vg(j,i) ) *( l_vg(j,i) + 2.0_wp) ) )
-
-!
-!--                Parametrization of Clapp & Hornberger
-                   ELSE
-                      gamma_temp(k) = gamma_w_sat(j,i) * ( m_soil(k,j,i)       &
-                                      / m_sat(j,i) )**(2.0_wp * b_ch + 3.0_wp)
-                   ENDIF
-
-                ENDDO
-
-!
-!--             Prognostic equation for soil moisture content. Only performed,
-!--             when humidity is enabled in the atmosphere and the surface type
-!--             is not pavement (implies dry soil below).
-                IF ( humidity  .AND.  .NOT.  pave_surface(j,i) )  THEN
-!
-!--                Calculate soil diffusivity (lambda_w) at the _stag level 
-!--                using linear interpolation. To do: replace this with
-!--                ECMWF-IFS Eq. 8.81
-                   DO  k = nzb_soil, nzt_soil-1
-                     
-                      lambda_w(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) )  &
-                                        * 0.5_wp
-                      gamma_w(k,j,i)  = ( gamma_temp(k+1) + gamma_temp(k) )    &
-                                        * 0.5_wp
-
-                   ENDDO
-
-!
-!
-!--                In case of a closed bottom (= water content is conserved), 
-!--                set hydraulic conductivity to zero to that no water will be 
-!--                lost in the bottom layer.
-                   IF ( conserve_water_content )  THEN
-                      gamma_w(nzt_soil,j,i) = 0.0_wp
-                   ELSE
-                      gamma_w(nzt_soil,j,i) = gamma_temp(nzt_soil)
-                   ENDIF     
-
-!--                The root extraction (= root_extr * qsws_veg_eb / (rho_l     
-!--                * l_v)) ensures the mass conservation for water. The         
-!--                transpiration of plants equals the cumulative withdrawals by 
-!--                the roots in the soil. The scheme takes into account the 
-!--                availability of water in the soil layers as well as the root 
-!--                fraction in the respective layer. Layer with moisture below 
-!--                wilting point will not contribute, which reflects the 
-!--                preference of plants to take water from moister layers.
-
-!
-!--                Calculate the root extraction (ECMWF 7.69, the sum of 
-!--                root_extr = 1). The energy balance solver guarantees a 
-!--                positive transpiration, so that there is no need for an 
-!--                additional check.
-                   m_total = 0.0_wp
-                   DO  k = nzb_soil, nzt_soil
-                       IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
-                          m_total = m_total + root_fr(k,j,i) * m_soil(k,j,i)
-                       ENDIF
-                   ENDDO  
-
-                   IF ( m_total > 0.0_wp )  THEN
-                      DO  k = nzb_soil, nzt_soil
-                         IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
-                            root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i)      &
-                                                            / m_total
-                         ELSE
-                            root_extr(k) = 0.0_wp
-                         ENDIF
-                      ENDDO
-                   ENDIF
-
-!
-!--                Prognostic equation for soil water content m_soil.
-                   tend(:) = 0.0_wp
-
-                   tend(nzb_soil) = ( lambda_w(nzb_soil,j,i) * (               &
-                            m_soil(nzb_soil+1,j,i) - m_soil(nzb_soil,j,i) )    &
-                            * ddz_soil(nzb_soil+1) - gamma_w(nzb_soil,j,i) - ( &
-                               root_extr(nzb_soil) * qsws_veg_eb(j,i)          &
-                               + qsws_soil_eb(j,i) ) * drho_l_lv )             &
-                               * ddz_soil_stag(nzb_soil)
-
-                   DO  k = nzb_soil+1, nzt_soil-1
-                      tend(k) = ( lambda_w(k,j,i) * ( m_soil(k+1,j,i)          &
-                                - m_soil(k,j,i) ) * ddz_soil(k+1)              &
-                                - gamma_w(k,j,i)                               &
-                                - lambda_w(k-1,j,i) * (m_soil(k,j,i) -         &
-                                m_soil(k-1,j,i)) * ddz_soil(k)                 &
-                                + gamma_w(k-1,j,i) - (root_extr(k)             &
-                                * qsws_veg_eb(j,i) * drho_l_lv)                &
-                                ) * ddz_soil_stag(k)
-
-                   ENDDO
-                   tend(nzt_soil) = ( - gamma_w(nzt_soil,j,i)                  &
-                                           - lambda_w(nzt_soil-1,j,i)          &
-                                           * (m_soil(nzt_soil,j,i)             &
-                                           - m_soil(nzt_soil-1,j,i))           &
-                                           * ddz_soil(nzt_soil)                &
-                                           + gamma_w(nzt_soil-1,j,i) - (       &
-                                             root_extr(nzt_soil)               &
-                                           * qsws_veg_eb(j,i) * drho_l_lv  )   &
-                                     ) * ddz_soil_stag(nzt_soil)             
-
-                   m_soil_p(nzb_soil:nzt_soil,j,i) = m_soil(nzb_soil:nzt_soil,j,i)&
-                                                   + dt_3d * ( tsc(2) * tend(:)   &
-                                                   + tsc(3) * tm_soil_m(:,j,i) )   
-   
-!
-!--                Account for dry soils (find a better solution here!)
-                   DO  k = nzb_soil, nzt_soil
-                      IF ( m_soil_p(k,j,i) < 0.0_wp )  m_soil_p(k,j,i) = 0.0_wp
-                   ENDDO
-
-!
-!--                Calculate m_soil tendencies for the next Runge-Kutta step
-                   IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                      IF ( intermediate_timestep_count == 1 )  THEN
-                         DO  k = nzb_soil, nzt_soil
-                            tm_soil_m(k,j,i) = tend(k)
-                         ENDDO
-                      ELSEIF ( intermediate_timestep_count <                   &
-                               intermediate_timestep_count_max )  THEN
-                         DO  k = nzb_soil, nzt_soil
-                            tm_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp&
-                                     * tm_soil_m(k,j,i)
-                         ENDDO
-                      ENDIF
-                   ENDIF
-
-                ENDIF
-
              ENDIF
 
-          ENDDO
+          ENDIF
+
        ENDDO
 
@@ -2386,10 +2855,19 @@
 
 #if defined( __nopointer )
-
-       t_surface    = t_surface_p
-       t_soil       = t_soil_p
+!
+!--    Horizontal surfaces
+       t_surface_h  = t_surface_h_p
+       t_soil_h     = t_soil_h_p
        IF ( humidity )  THEN
-          m_soil    = m_soil_p
-          m_liq_eb  = m_liq_eb_p
+          m_soil_h    = m_soil_h_p
+          m_liq_eb_h  = m_liq_eb_h_p
+       ENDIF
+!
+!--    Vertical surfaces
+       t_surface_v  = t_surface_v_p
+       t_soil_v     = t_soil_v_p
+       IF ( humidity )  THEN
+          m_soil_v    = m_soil_v_p
+          m_liq_eb_v  = m_liq_eb_v_p
        ENDIF
 
@@ -2399,20 +2877,39 @@
 
           CASE ( 0 )
-
-             t_surface  => t_surface_1; t_surface_p  => t_surface_2
-             t_soil     => t_soil_1;    t_soil_p     => t_soil_2
+!
+!--          Horizontal surfaces
+             t_surface_h  => t_surface_h_1; t_surface_h_p  => t_surface_h_2
+             t_soil_h     => t_soil_h_1;    t_soil_h_p     => t_soil_h_2
              IF ( humidity )  THEN
-                m_soil    => m_soil_1;   m_soil_p    => m_soil_2
-                m_liq_eb  => m_liq_eb_1; m_liq_eb_p  => m_liq_eb_2
+                m_soil_h    => m_soil_h_1;   m_soil_h_p    => m_soil_h_2
+                m_liq_eb_h  => m_liq_eb_h_1; m_liq_eb_h_p  => m_liq_eb_h_2
              ENDIF
+!
+!--          Vertical surfaces
+             t_surface_v  => t_surface_v_1; t_surface_v_p  => t_surface_v_2
+             t_soil_v     => t_soil_v_1;    t_soil_v_p     => t_soil_v_2
+             IF ( humidity )  THEN
+                m_soil_v    => m_soil_v_1;   m_soil_v_p    => m_soil_v_2
+                m_liq_eb_v  => m_liq_eb_v_1; m_liq_eb_v_p  => m_liq_eb_v_2
+             ENDIF
+
 
 
           CASE ( 1 )
-
-             t_surface  => t_surface_2; t_surface_p  => t_surface_1
-             t_soil     => t_soil_2;    t_soil_p     => t_soil_1
+!
+!--          Horizontal surfaces
+             t_surface_h  => t_surface_h_2; t_surface_h_p  => t_surface_h_1
+             t_soil_h     => t_soil_h_2;    t_soil_h_p     => t_soil_h_1
              IF ( humidity )  THEN
-                m_soil    => m_soil_2;   m_soil_p    => m_soil_1
-                m_liq_eb  => m_liq_eb_2; m_liq_eb_p  => m_liq_eb_1
+                m_soil_h    => m_soil_h_2;   m_soil_h_p    => m_soil_h_1
+                m_liq_eb_h  => m_liq_eb_h_2; m_liq_eb_h_p  => m_liq_eb_h_1
+             ENDIF
+!
+!--          Vertical surfaces
+             t_surface_v  => t_surface_v_2; t_surface_v_p  => t_surface_v_1
+             t_soil_v     => t_soil_v_2;    t_soil_v_p     => t_soil_v_1
+             IF ( humidity )  THEN
+                m_soil_v    => m_soil_v_2;   m_soil_v_p    => m_soil_v_1
+                m_liq_eb_v  => m_liq_eb_v_2; m_liq_eb_v_p  => m_liq_eb_v_1
              ENDIF
 
@@ -2445,7 +2942,8 @@
     CHARACTER (LEN=*) :: variable !< 
 
-    INTEGER(iwp) ::  i !< 
-    INTEGER(iwp) ::  j !< 
-    INTEGER(iwp) ::  k !< 
+    INTEGER(iwp) ::  i       !< 
+    INTEGER(iwp) ::  j       !< 
+    INTEGER(iwp) ::  k       !< 
+    INTEGER(iwp) ::  m       !< running index
 
     IF ( mode == 'allocate' )  THEN
